import { Injector, OnDestroy } from '@angular/core';
import { BaseEntityFeatureFactory } from '../model';
import { TraitEffect } from '../trait-effect';
import * as i0 from "@angular/core";
export declare function buildLocalTraits<State, F extends BaseEntityFeatureFactory<any, any, any>>(injector: Injector, componentName: string, traitFactory: F): {
    destroy: () => void;
    actions: any;
    selectors: any;
    addEffects(localEffect: TraitEffect): void;
};
export interface Type<T> extends Function {
    new (...args: any[]): T;
}
export interface LocalTraitsConfig<F extends BaseEntityFeatureFactory<any, any, any>> {
    componentName: string;
    traitsFactory: F;
}
export declare abstract class TraitsLocalStore<F extends BaseEntityFeatureFactory<any, any, any>> extends TraitEffect implements OnDestroy {
    injector: Injector;
    traits: {
        actions: ReturnType<F>['actions'];
        selectors: ReturnType<F>['selectors'];
        destroy: () => void;
        addEffects: (localEffect: TraitEffect) => void;
    };
    localActions: ReturnType<F>['actions'];
    localSelectors: ReturnType<F>['selectors'];
    constructor(injector: Injector);
    abstract setup(): LocalTraitsConfig<F>;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TraitsLocalStore<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<TraitsLocalStore<any>>;
}
